/*
 * Java Genetic Algorithm Library (jenetics-1.6.0).
 * Copyright (c) 2007-2014 Franz Wilhelmstötter
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Author:
 *    Franz Wilhelmstötter (franz.wilhelmstoetter@gmx.at)
 */
package org.jenetics.util;

import org.testng.Assert;
import org.testng.annotations.Test;

/**
 * @author <a href="mailto:franz.wilhelmstoetter@gmx.at">Franz Wilhelmstötter</a>
 * @version <em>$Date: 2014-02-15 $</em>
 */
public class StaticObjectTest {

	@Test
	public void instantiation()
		throws InstantiationException, IllegalAccessException
	{
		try {
			new StaticObject() {};
			Assert.assertFalse(true);
		} catch (AssertionError e) {
			final String expected = String.format(
				"Instantiation of '%s' is not allowed.",
				"org.jenetics.util.StaticObjectTest$1"
			);

			Assert.assertEquals(e.getMessage(), expected);
		}

		try {
			new SomeStaticObject();
			Assert.assertFalse(true);
		} catch (AssertionError e) {
			final String expected = String.format(
				"Instantiation of '%s' is not allowed.",
				"org.jenetics.util.SomeStaticObject"
			);

			Assert.assertEquals(e.getMessage(), expected);
		}

		try {
			SomeStaticObject.class.newInstance();
			Assert.assertFalse(true);
		} catch (AssertionError e) {
			final String expected = String.format(
				"Instantiation of '%s' is not allowed.",
				"org.jenetics.util.SomeStaticObject"
			);

			Assert.assertEquals(e.getMessage(), expected);
		}
	}

}

final class SomeStaticObject extends StaticObject {}
